using System;
using System.Collections.Generic;
using System.Text;
/*
Copyright 2010 Mirosaw M. Mczka

This file is part of Mp3Cleaner.

    Mp3Cleaner is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/
namespace Mp3Edit
{
    class CleanNames
    {
        public static void DoClean(ref string[] names, bool isRemoveCommon)
        {
            string[] trackNo = new string[names.GetLength(0)];
            DoClean(ref names, ref trackNo, isRemoveCommon);
        }
        //-----------------------------------------------------------------------------------
        public static void DoClean(ref string[] names, ref string[] trackNo, bool isRemoveCommon)
        {
            int kount = names.GetLength(0);
            FileNameConversion fnc = new FileNameConversion();
            //
            //string commonS0 = string.Empty;
            string commonS = string.Empty;
            string commonE = string.Empty;
            //
            string[] ssNames = new string[kount];
            string[] nnSeq = new string[kount];
            //
            for (int k = 0; k < kount; k++)//jeeli liczba na poczatku
            {
                //
                ssNames[k] = names[k];
                if (!Utils.isTrackNumberEmpty(trackNo[k]))//numer cieki ju jest, pomin
                {
                    nnSeq[k] = trackNo[k];
                    continue;
                }
                else
                {
                    nnSeq[k] = "";
                }
                //
                if (Utils.isNumberOnly(names[k]))
                {
                    ssNames[k] = names[k];
                    nnSeq[k] = "";
                    continue;//tylko numer w nazwie - nie rusza
                }
            }//for
            //
            // wyszukiwanie wsplnej czci napisw
            //
            commonS = "";
            commonE = "";
            //
            //
            if (kount > 1)// pojedynczy zawsze bdzie do siebie pasowa
            {
                // najpierw poczatek
                if(isRemoveCommon)commonS = fnc.GetCommonStart(ssNames);
                //
                if ("" != commonS)
                {// jeeli jest takowy, to usuwamy go z tekstu
                    for (int k = 0; k < kount; k++)
                    {
                        if (ssNames[k].Length >= commonS.Length)
                        {
                            ssNames[k] = ssNames[k].Substring(commonS.Length);
                        }
                    }
                }
                //
                //
                // teraz koniec
                if (isRemoveCommon) commonE = fnc.GetCommonEnd(ssNames);
                //
                //
                if ("" != commonE)
                {// jeeli jest takowy, to usuwamy go z tekstu
                    for (int k = 0; k < kount; k++)
                    {
                        if ((ssNames[k].Length - commonE.Length) > 0)
                        {
                            ssNames[k] = ssNames[k].Substring(0, ssNames[k].Length - commonE.Length);
                        }
                    }
                }
            }//if (kount > 1)
            //
            //
            for (int k = 0; k < kount; k++)
            {
                //
                if (Utils.isTrackNumberEmpty(nnSeq[k]))// numeru nie ma
                {
                    if (Utils.isNumberOnly(ssNames[k]))//tylko numer w nazwie - nie rusza
                    {
                        nnSeq[k] = ssNames[k];
                    }
                    else
                    {
                        string name = ""; string seq = "";
                        name = fnc.getNumberClean(ssNames[k], out seq);// prbujemy znale numer scieki na pocztku
                        //
                        if (Utils.isTrackNumberEmpty(seq))
                        {// nie byo
                            name = fnc.getNumberAtEnd(ssNames[k], out seq);// no to moe jest na kocu
                            if (!Utils.isTrackNumberEmpty(seq))
                            {//jest na kocu
                                ssNames[k] = name;
                                nnSeq[k] = seq;
                            }
                            else
                            {// nie byo n kocu
                                name = fnc.getNumber2Clean(ssNames[k], out seq);// prbujemy znale numer scieki jako DRUGI numer w tekcie
                                if (!Utils.isTrackNumberEmpty(seq))
                                {//jest jako drugi
                                    ssNames[k] = name;
                                    nnSeq[k] = seq;
                                }
                            }
                        }
                        else
                        {// by na poczatku
                            ssNames[k] = name;
                            nnSeq[k] = seq;
                        }
                        //
                    }
                }
                //
                //
                trackNo[k] = nnSeq[k];
                names[k] = ssNames[k];
                //
            }// for
            //
            if (Utils.areAllTracksEmpty(trackNo))
            {
                if (Utils.areAllTracksNumbers(names))
                {
                    // numer cieki pusty, w nazwie cieki tylko numer
                    for (int k=0; k<names.Length; k++)
                    {
                        trackNo[k] = names[k];
                    }
                }
            }
            //
            //
            // powtrne sprawdzenie nazwy na powtrki
            commonS = "";
            //
            // najpierw poczatek
            if (isRemoveCommon) commonS = fnc.GetCommonStart(ssNames);
            //
            if ("" != commonS)
            {// jeeli jest takowy, to usuwamy go z tekstu
                for (int k = 0; k < kount; k++)
                {
                    if (ssNames[k].Length >= commonS.Length)
                    {
                        names[k] = ssNames[k].Substring(commonS.Length);
                    }
                }
            }
            //
            //
            for (int k = 0; k < kount; k++)
            {
                names[k] = names[k].Replace('_', ' ');
                if (Utils.isDotsInsteadSpaces(names[k])) names[k] = names[k].Replace('.', ' ');
                names[k] = CaseUtils.ToCamelIfNeeded(names[k].Trim());
            }
            //
            return;
        }
        //-----------------------------------------------------------------------------------
    }//class
}//namespace
