﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
//
using System.IO;
using System.Configuration;
using System.Reflection;
using System.Diagnostics;/*
Copyright 2010 Mirosław M. Mączka

This file is part of Mp3Cleaner.

    Mp3Cleaner is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/
namespace Mp3Edit
{
    public partial class Form1 : Form
    {
        //---------------------------------------------------------------------------------------------------------------------------------
        //---------------------------------------------------------------------------------------------------------------------------------
        private void afterLoad(bool isLoadNewFile)
        {
            button_100.Enabled = false;
            button_200.Enabled = false;
            button_300.Enabled = false;
            button_400.Enabled = false;
            //
            isTrackMuliplied = false;
            //
            if (isLoadNewFile)
            {
                checkBox_RemoveCommon.Checked = true;
                isTrackMuliplied = false;
            }
            else
            {
                checkBox_RemoveCommon.Checked = !isTrackMuliplied;
            }
            //

            //
        }
        private void afterClean()
        {
            button_100.Enabled = true;
            button_200.Enabled = true;
            button_300.Enabled = true;
            button_400.Enabled = true;
        }
        private void afterWrite()
        {
            //checkBox_RemoveCommon.Checked = true;
        }
        //
        //---------------------------------------------------------------------------------------------------------------------------------
        //---------------------------------------------------------------------------------------------------------------------------------
        //
        private string getVersionInfo()
        {
            //
            string cc = System.Globalization.CultureInfo.CurrentCulture.TextInfo.CultureName;
            //
            if (System.Deployment.Application.ApplicationDeployment.IsNetworkDeployed)
            {
                //działa tylko na zainstalowanym sieciowo programie!
                return string.Format("Version: {0} ({1})", System.Deployment.Application.ApplicationDeployment.CurrentDeployment.CurrentVersion, cc);
            }
            //
            Assembly ass = Assembly.GetExecutingAssembly();
            if (ass != null)
            {
                FileVersionInfo fvi = FileVersionInfo.GetVersionInfo(ass.Location);
                return String.Format("Version: {0} ({1})", fvi.ProductVersion, cc);
            }
            //
            return "Version: unknown";
        }
        //
        //---------------------------------------------------------------------------------------------------------------------------------
        //---------------------------------------------------------------------------------------------------------------------------------
        private bool checkFirstTime()
        {
            //
            if (true == Properties.Settings.Default.isFirstTime)
            {
                Properties.Settings.Default.isFirstTime = false;
                //
                Help.ShowHelpIndex(this, helpProvider1.HelpNamespace);
                //MessageBox.Show(labelInfoText.Text, labelInfoCaption.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
                //
                return true;
            }
            //
            return false;
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Wczytauje pliki z bieżącego katalogu
        /// </summary>
        /// <param name="isLoadNewFile">Czy wczytuje pliki pierwszy raz (nowe)</param>
        /// <returns></returns>
        private bool loadDir()
        {
            string[] dirFiles = null;
            string currentFileExt = "";
            TagLibConnector tlc = new TagLibConnector();
            //
            foreach (string mfe in MusicFilesExtensions)
            {
                if (string.Empty == mfe.Trim()) continue;
                dirFiles = Directory.GetFiles(StartDirectory, @"*" + mfe);
                if (dirFiles.GetLength(0) > 0)
                {
                    currentFileExt = mfe;
                    break;
                }

            }
            //
            
            dataSet1.DirTable1.Clear();
            //
            //GetTagsFromFile.GetCapabilities(currentFileExt, out isHandled, out isWritable);
            //
            int failsCount = 0;
            Cursor.Current = Cursors.WaitCursor;
            foreach (string fn in dirFiles)
            {
                string fileName = Path.GetFileNameWithoutExtension(fn);
                string fileExt = Path.GetExtension(fn);
                //
                //string tagTrack, tagTitle, tagArtist, tagAlbum, tagYear, tagGenre;
                //tagTrack=""; tagTitle=""; tagArtist=""; tagAlbum=""; tagYear=""; tagGenre="";
                //
                if (!tlc.ReadTags(fn)) failsCount++;
                //GetTagsFromFile.GetTags(currentFileExt, fn, out tagTrack, out tagTitle, out tagArtist, out tagAlbum, out tagYear, out tagGenre);
                //
                //dataSet11.DirTable1.AddDirTable1Row(false, fileName, fileExt, "", fileName + fileExt, 0, tagTrack, tagTitle, tagArtist, tagAlbum, tagYear, tagGenre);
                //dataSet1.DirTable1.AddDirTable1Row(false, fileName, fileExt, "", fileName, 0, tlc.tagTrack, tlc.tagTitle, tlc.tagArtist, tlc.tagAlbum, tlc.tagYear, tlc.tagGenre);
                dataSet1.DirTable1.AddDirTable1Row(false, Path.GetFileName(fn), "", false, fileName, false, fileExt, tlc.tagTrack, false, tlc.tagTitle, false, tlc.tagArtist, false, tlc.tagAlbum, false, tlc.tagYear, false, tlc.tagGenre, false, 0);
            }
            Cursor.Current = Cursors.Default;
            //
            return true;
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        private bool setInfoFromPath(string startDirectory)
        {
            DirAlbum = "";// [Year] Album
            DirArtist = ""; // Artist
            string[] dirs = startDirectory.Split('\\');
            if (dirs.GetLength(0) >= 1) DirAlbum = dirs[dirs.GetLength(0) - 1];// [Year] Album
            if (dirs.GetLength(0) >= 2) DirArtist = dirs[dirs.GetLength(0) - 2];// Artist
            //
            this.Text = DirArtist + "/" + DirAlbum;
            //
            return dirs.GetLength(0) >= 2;
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        //---------------------------------------------------------------------------------------------------------------------------------
        private void Copy_FileName_2_tagTitle()
        {
            string fn;
            bool isTouched = false;
            for (int k = 0; k < dataSet1.DirTable1.Count; k++)
            {
                fn = dataSet1.DirTable1[k].FileName;
                //fn = Path.GetFileNameWithoutExtension(fn);
                dataSet1.DirTable1[k].tagTitle = fn;
                dataSet1.DirTable1[k].tagTitle_Changed = true;
                //
                isTouched = true;
                dataSet1.DirTable1[k].Marker = true;
            }
            //
            if (isTouched) checkBox_UpdateTags.Checked = true;
            //
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        private void Copy_tagTitle_2_FileName()
        {
            for (int k = 0; k < dataSet1.DirTable1.Count; k++)
            {
                dataSet1.DirTable1[k].FileName = Utils.CleanFileName(dataSet1.DirTable1[k].tagTitle);
                //
                dataSet1.DirTable1[k].FileName_Changed = true;
                dataSet1.DirTable1[k].Marker = true;
            }
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        private void Copy_FileTrack_2_tagTrack()
        {
            string trNo;
            int i;
            bool isTouched = false;
            for (int k = 0; k < dataSet1.DirTable1.Count; k++)
            {
                trNo = dataSet1.DirTable1[k].FileTrack;
                trNo = trNo.Trim();
                if ("" == trNo) continue;
                if (!int.TryParse(trNo, out i)) continue;
                trNo = GetLegalTrackNumber(trNo);
                //
                dataSet1.DirTable1[k].tagTrack = trNo;
                dataSet1.DirTable1[k].tagTrack_Changed = true;
                //
                isTouched = true;
                dataSet1.DirTable1[k].Marker = true;
            }
            //
            if (isTouched) checkBox_UpdateTags.Checked = true;
            //
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        private void Copy_tagTrack_2_FileTrack()
        {
            string trNo;
            for (int k = 0; k < dataSet1.DirTable1.Count; k++)
            {
                trNo = dataSet1.DirTable1[k].tagTrack.Trim();
                if (("" != trNo) && (trNo.Length < 2)) trNo = "0" + trNo;
                dataSet1.DirTable1[k].FileTrack = trNo;
                //
                dataSet1.DirTable1[k].FileName_Changed = true;
                dataSet1.DirTable1[k].Marker = true;
            }
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        //---------------------------------------------------------------------------------------------------------------------------------
        private void SetTagTitleAuthor(int nPos, string title, string artist)
        {
            title = title.Trim();
            artist = artist.Trim();
            //
            if ("" == title) return;
            //
            if (nPos >= dataSet1.DirTable1.Count) return;
            //
            dataSet1.DirTable1[nPos].tagTitle = title;
            dataSet1.DirTable1[nPos].tagTitle_Changed = true;
            //
            if ("" != artist)
            {
                dataSet1.DirTable1[nPos].tagArtist = artist;
                dataSet1.DirTable1[nPos].tagArtist_Changed = true;
            }
            //
            dataSet1.DirTable1[nPos].Marker = true;
            //
            checkBox_UpdateTags.Checked = true;
            //
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        //---------------------------------------------------------------------------------------------------------------------------------
        private void SetTagAlbum(string album)
        {
            bool isTouched = false;
            //
            album = album.Trim();
            album = Utils.RemoveTrailingTildes(album);
            //
            if ("" == album) return;
            //
            //
            for (int k = 0; k < dataSet1.DirTable1.Count; k++)
            {
                dataSet1.DirTable1[k].tagAlbum = album;
                //
                isTouched = true;
                dataSet1.DirTable1[k].tagAlbum_Changed = true;
                dataSet1.DirTable1[k].Marker = true;
            }
            if (isTouched) checkBox_UpdateTags.Checked = true;
            //
        }
        //--------------------------------------
        private void SetTagArtist(string artist)
        {
            bool isTouched = false;
            //
            artist = artist.Trim();
            if ("" == artist) return;
            //
            for (int k = 0; k < dataSet1.DirTable1.Count; k++)
            {
                dataSet1.DirTable1[k].tagArtist = artist;
                //
                isTouched = true;
                dataSet1.DirTable1[k].tagArtist_Changed = true;
                dataSet1.DirTable1[k].Marker = true;
            }
            if (isTouched) checkBox_UpdateTags.Checked = true;
        }
        //--------------------------------------
        private void SetTagYear(string year)
        {
            bool isTouched = false;
            //
            year = year.Trim();
            // biblioteka nie chce zapisywać pustego roku!
            if ("" == year)return ;
            {
                int i;
                if (!int.TryParse(year, out i)) return;
                if (i < 1800 && i > DateTime.Now.Year) return;
            }
            //
            //
            isTouched = true;
            for (int k = 0; k < dataSet1.DirTable1.Count; k++)
            {
                dataSet1.DirTable1[k].tagYear = year;
                //
                dataSet1.DirTable1[k].tagYear_Changed = true;
                dataSet1.DirTable1[k].Marker = true;
            }
            if (isTouched) checkBox_UpdateTags.Checked = true;
        }
        //--------------------------------------
        private void SetTagGenre(string genre)
        {
            bool isTouched = false;
            //
            genre = genre.Trim();
            //
            for (int k = 0; k < dataSet1.DirTable1.Count; k++)
            {
                dataSet1.DirTable1[k].tagGenre = genre;
                //
                isTouched = true;
                dataSet1.DirTable1[k].tagGenre_Changed = true;
                dataSet1.DirTable1[k].Marker = true;
            }
            if (isTouched) checkBox_UpdateTags.Checked = true;
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        private void Split_tagTitle2tagTitletagAuthor(bool reverse)
        {
            bool isTouched = false;
            //
            string aa = "";
            string[] at = null;
            string artist = "";
            string title = "";
            //
            for (int k = 0; k < dataSet1.DirTable1.Count; k++)
            {
                aa = dataSet1.DirTable1[k].tagTitle;// "author - title"
                // znamiem podziału może być tylko:'/' i '-'
                at = aa.Split(new char[] { '/' }, 2);
                if (1 == at.GetLength(0))
                {
                    at = aa.Split(new char[] { '-' }, 2);
                }
                if (1 == at.GetLength(0)) continue;
                //
                if (!reverse)
                {
                    artist = at[0].Trim(); title = at[1].Trim();
                }
                else
                {
                    artist = at[1].Trim(); title = at[0].Trim();
                }
                //
                if (("" == artist) || ("" == title)) continue;
                //
                artist = CaseUtils.ToCamelIfNeeded(artist); title = CaseUtils.ToCamelIfNeeded(title);
                //
                dataSet1.DirTable1[k].tagArtist = artist;
                dataSet1.DirTable1[k].tagTitle = title;
                //
                isTouched = true;
                dataSet1.DirTable1[k].tagArtist_Changed = true;
                dataSet1.DirTable1[k].tagTitle_Changed = true;
                dataSet1.DirTable1[k].Marker = true;
            }
            if (isTouched) checkBox_UpdateTags.Checked = true;
        }
        //--------------------------------------
        private void Concat_tagArtisttagTitle2FileName(bool reverse)
        {
            bool isTouched = false;
            //
            string artist = "";
            string title = "";
            //
            for (int k = 0; k < dataSet1.DirTable1.Count; k++)
            {
                //
                artist = dataSet1.DirTable1[k].tagArtist.Trim();
                title = dataSet1.DirTable1[k].tagTitle.Trim();
                //
                if (("" == artist) && ("" == title)) continue;
                //
                artist = CaseUtils.ToCamelIfNeeded(artist); title = CaseUtils.ToCamelIfNeeded(title);
                //
                if (!reverse)
                {
                    dataSet1.DirTable1[k].FileName = Utils.CleanFileName(artist + " - " + title);
                }
                else
                {
                    dataSet1.DirTable1[k].FileName = Utils.CleanFileName(title + " - " + artist);
                }
                //
                isTouched = true;
                dataSet1.DirTable1[k].FileName_Changed = true;
                dataSet1.DirTable1[k].Marker = true;
            }
            if (isTouched) checkBox_UpdateTags.Checked = true;
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        private void DoRemove()
        {
            string fnameOld = string.Empty, fnameNew = string.Empty, regEx = string.Empty;
            //
            InputBox.InputBoxResult ibr = InputBox.Show("Remove:", "Remove", regEx);
            if (!ibr.OK) return;
            regEx = ibr.Text;
            //
            regEx = regEx.Trim();
            if ("" == regEx) return;
            //
            //
            for (int k = 0; k < dataSet1.DirTable1.Count; k++)
            {
                fnameOld = dataSet1.DirTable1[k].FileName;
                fnameNew = Utils.ReplaceRegular(fnameOld, "", regEx).Trim();
                //
                if (string.Empty == fnameNew)
                {
                    continue;
                }
                //
                if (0 != String.Compare(fnameOld, fnameNew, true))
                {
                    dataSet1.DirTable1[k].FileName = fnameNew;
                    //
                    dataSet1.DirTable1[k].FileName_Changed = true;
                    dataSet1.DirTable1[k].Marker = true;
                }
            }
            //
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        private void DoClean()
        {
            //
            FileNameConversion fnc = new FileNameConversion();
            //-------------------------------------------------------------------------------------------
            // FileName
            //
            {
                string[] ssTrackSrc = new string[dataSet1.DirTable1.Count];
                string[] ssNamesSrc = new string[dataSet1.DirTable1.Count];
                bool[] isChanged = new bool[dataSet1.DirTable1.Count];
                for (int kk = 0; kk < dataSet1.DirTable1.Count; kk++)
                {
                    ssTrackSrc[kk] = dataSet1.DirTable1[kk].FileTrack.Trim();
                    ssNamesSrc[kk] = dataSet1.DirTable1[kk].FileName.Trim();
                    isChanged[kk]=false;
                }
                //
                splitName(ssTrackSrc, ssNamesSrc, isChanged);
                //
                // specyfika nazw plików, muszą istnieć, składać się tylko z legalnych znaków i być unikalne
                //
                for (int kk = 0; kk < dataSet1.DirTable1.Count; kk++)
                {
                    //
                    ssNamesSrc[kk] = Utils.CleanFileName(ssNamesSrc[kk].Trim());
                    //
                    //
                    if (Utils.isTrackNumberEmpty(ssTrackSrc[kk]) && ("" != ssNamesSrc[kk]))
                    {
                        Int32 n;
                        if (Int32.TryParse(ssNamesSrc[kk], out n))
                        {
                            ssTrackSrc[kk] = ssTrackSrc[kk];
                            ssNamesSrc[kk] = "_" + ssNamesSrc[kk];
                            //
                            isChanged[kk] = true;
                        }
                    }
                    //
                    //
                    if (!Utils.isTrackNumberEmpty(ssTrackSrc[kk]) && "" == ssNamesSrc[kk])
                    {
                        ssNamesSrc[kk] = "_" + ssNamesSrc[kk];
                        //
                        isChanged[kk] = true;
                    }
                }
                //
                for (int kk = 0; kk < dataSet1.DirTable1.Count; kk++)
                {
                    if (isChanged[kk])
                    {
                        dataSet1.DirTable1[kk].FileTrack = ssTrackSrc[kk];
                        dataSet1.DirTable1[kk].FileName = ssNamesSrc[kk];
                    }
                    //
                    // ustawienie markera - tylko wtedy, gdy nazwa pliku faktycznie się zmieniła
                    if(0 != String.Compare(dataSet1.DirTable1[kk].Disk_FullFileName, dataSet1.DirTable1[kk].FileTrack + " " + dataSet1.DirTable1[kk].FileName + dataSet1.DirTable1[kk].FileExt, false))
                    {
                        dataSet1.DirTable1[kk].FileName_Changed = true;
                        dataSet1.DirTable1[kk].Marker = true;
                    }
                    else
                    {
                        dataSet1.DirTable1[kk].FileName_Changed = false;
                        dataSet1.DirTable1[kk].Marker = false;
                    }
                    //
                }
                //
            }
            //
            //===========================================================================================
            //
            // tagi
            //
            //-------------------------------------------------------------------------------------------
            // Title
            //
            {
                string[] ssTrackSrc = new string[dataSet1.DirTable1.Count];
                string[] ssNamesSrc = new string[dataSet1.DirTable1.Count];
                bool[] isChanged = new bool[dataSet1.DirTable1.Count];
                for (int kk = 0; kk < dataSet1.DirTable1.Count; kk++)
                {
                    ssTrackSrc[kk] = dataSet1.DirTable1[kk].tagTrack;
                    ssNamesSrc[kk] = dataSet1.DirTable1[kk].tagTitle;
                    isChanged[kk] = false;
                }
                //
                WinylTrackNumbers.CnvIfAny(ssNamesSrc, isChanged);
                //
                splitName(ssTrackSrc, ssNamesSrc, isChanged);
                //
                for (int kk = 0; kk < dataSet1.DirTable1.Count; kk++)
                {
                    if (isChanged[kk])
                    {
                        dataSet1.DirTable1[kk].tagTrack = ssTrackSrc[kk];
                        dataSet1.DirTable1[kk].tagTitle = ssNamesSrc[kk];
                        dataSet1.DirTable1[kk].tagTrack_Changed = true;
                        dataSet1.DirTable1[kk].Marker = true;
                    }
                }
                //
            }
            //
            //-------------------------------------------------------------------------------------------
            // Artist -> to Camel
            //
            {
                string[] ssText = new string[dataSet1.DirTable1.Count];
                string s;
                for (int kk = 0; kk < dataSet1.DirTable1.Count; kk++)
                {
                    s = CaseUtils.ToCamelIfNeeded(dataSet1.DirTable1[kk].tagArtist.Trim());
                    if (0 != String.Compare(dataSet1.DirTable1[kk].tagArtist, s, false))
                    {// case sie liczy
                        dataSet1.DirTable1[kk].tagArtist_Changed = true;
                        dataSet1.DirTable1[kk].Marker = true;
                    }
                    ssText[kk] = s;
                }
                //
                for (int kk = 0; kk < dataSet1.DirTable1.Count; kk++)
                {
                    dataSet1.DirTable1[kk].tagArtist = ssText[kk];
                }
                //
            }
            //
            //-------------------------------------------------------------------------------------------
            // Album -> to Camel
            //
            {
                string[] ssText = new string[dataSet1.DirTable1.Count];
                string s;
                for (int kk = 0; kk < dataSet1.DirTable1.Count; kk++)
                {
                    s = CaseUtils.ToCamelIfNeeded(dataSet1.DirTable1[kk].tagAlbum.Trim());
                    if (0 != String.Compare(dataSet1.DirTable1[kk].tagAlbum, s, false))
                    {// case sie liczy
                        dataSet1.DirTable1[kk].tagAlbum_Changed = true;
                        dataSet1.DirTable1[kk].Marker = true;
                    }
                    //
                    if (Utils.RemoveTrailingTildes(s) != s)
                    {
                        s = Utils.RemoveTrailingTildes(s);
                        dataSet1.DirTable1[kk].tagAlbum_Changed = true;
                        dataSet1.DirTable1[kk].Marker = true;
                    }
                    ssText[kk] = s;
                }
                //
                for (int kk = 0; kk < dataSet1.DirTable1.Count; kk++)
                {
                    dataSet1.DirTable1[kk].tagAlbum = ssText[kk];
                }
                //
            }
            //
            //
            dataGridView1.Refresh();
            //
            //
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Dzieli nazwę typu "10 track 1" na elementy: numer scieżki i nazwę
        /// </summary>
        /// <param name="ssTracksSrc"></param>
        /// <param name="ssNamesSrc"></param>
        /// <param name="isChanged"></param>
        /// <returns></returns>
        private bool splitName(string[] ssTracksSrc, string[] ssNamesSrc, bool [] isChanged)
        {
            //
            int kount = ssNamesSrc.Length;
            FileNameConversion fnc = new FileNameConversion();
            //
            //isChanged = new bool[kount];
            string[] ssTracks = new string[kount];
            string[] ssTitles = new string[kount];
            //
            string[] ssTracks2 = new string[kount];
            //
            for (int kk = 0; kk < kount; kk++)
            {
                ssTracks[kk] = ssTracksSrc[kk].Trim();
                ssTitles[kk] = ssNamesSrc[kk].Trim();
            }
            //
            //-----------------------------------------------------------------------------------
            //
            // wydobywa numer ze ścieżki
            CleanNames.DoClean(ref ssTitles, ref ssTracks, checkBox_RemoveCommon.Checked);
            //
            for (int kk = 0; kk < kount; kk++)
            {
                // czy faktycznie doszło do zmiany nazwy
                if (0 != String.Compare(ssNamesSrc[kk], ssTitles[kk], false))
                {// case sie liczy
                    isChanged[kk] = true;
                }
                ssNamesSrc[kk] = ssTitles[kk];
                //
                if (Utils.isTrackNumberEmpty(ssTracksSrc[kk]))//tylko, gdy numer pusty przepisywać
                {
                    if (Utils.isTrackNumberEmpty(ssTracks[kk]))
                    {
                        if (!Utils.isTrackNumberEmpty(ssTracks2[kk]))
                        {
                            //ssTracks[kk] = ssTracks2[kk];
                            ssTracksSrc[kk] = ssTracks[kk];
                            //
                            isChanged[kk] = true;
                        }
                    }
                    else
                    {
                        ssTracksSrc[kk] = ssTracks[kk];
                        //
                        isChanged[kk] = true;
                    }
                }
                else if (ssTracksSrc[kk] == ssTracks2[kk])
                {
                    ssTracksSrc[kk] = ssTracks[kk];
                    //
                    isChanged[kk] = true;
                }
                //
            }//for()
            //
            //
            // sprawdzenie, czy to nie jest powtórka naumeru "10 10 AAAA"
            // (raczej nie bywa takich zająknięć więcej niż jedno
            {
                string[] _ssTitles = new string[kount];
                string[] _ssTracks = new string[kount];
                Array.Copy(ssNamesSrc, _ssTitles, ssNamesSrc.Length);
                CleanNames.DoClean(ref _ssTitles, ref _ssTracks, checkBox_RemoveCommon.Checked);
                if (Utils.areAllTracksNumbers(_ssTracks))//numery ścieżek wyglądają na poprawne
                {
                    for (int kk = 0; kk < kount; kk++)
                    {
                        if (!Utils.isTrackNumberEmpty(ssTracksSrc[kk]) && !Utils.isTrackNumberEmpty(_ssTracks[kk]))
                        {
                            if (ssTracksSrc[kk] == _ssTracks[kk])
                            {
                                ssNamesSrc[kk] = _ssTitles[kk];
                                //
                                isChanged[kk] = true;
                            }
                        }
                    }
                }

            }
            //
            //
            //
            return true;
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        private void DoWrite()
        {
            TagLibConnector tgl = null;
            string nameOld;
            string nameNew;
            //
            //
            Cursor.Current = Cursors.WaitCursor;
            for (int k = 0; k < dataSet1.DirTable1.Count; k++)
            {
                //
                //
                nameOld = StartDirectory + @"\" + dataSet1.DirTable1[k].Disk_FullFileName;
                //
                if (0 != String.Compare(dataSet1.DirTable1[k].FileExt, CaseUtils.ToLower(dataSet1.DirTable1[k].FileExt), false))// tylko, gdy faktycznie różne nazwy
                {
                    dataSet1.DirTable1[k].FileExt = CaseUtils.ToLower(dataSet1.DirTable1[k].FileExt);
                    dataSet1.DirTable1[k].FileName_Changed = true;
                    dataSet1.DirTable1[k].Marker = true;
                }
                //
                nameNew = StartDirectory + @"\";// +dataSet11.DirTable1[k].Number + @" " + dataSet11.DirTable1[k].FileNameNew;
                if ("" != dataSet1.DirTable1[k].FileTrack)
                {
                    nameNew += dataSet1.DirTable1[k].FileTrack + @" " + dataSet1.DirTable1[k].FileName + dataSet1.DirTable1[k].FileExt;
                }
                else
                {
                    nameNew += dataSet1.DirTable1[k].FileName + dataSet1.DirTable1[k].FileExt;
                }
                //
                //
                // wpisujemy tagi jeżeli były zmienione - albo checkBox_UpdateTags zaznaczony, nazwa pliku jeszcze nie zmieniona
                // albo - tp jest MP3 i ma starego taga na końcu
                if (Mp3OldTag.isOldTag(nameOld) || checkBox_UpdateTags.Checked || dataSet1.DirTable1[k].tagTrack_Changed || dataSet1.DirTable1[k].tagTitle_Changed || dataSet1.DirTable1[k].tagArtist_Changed || dataSet1.DirTable1[k].tagAlbum_Changed || dataSet1.DirTable1[k].tagYear_Changed || dataSet1.DirTable1[k].tagGenre_Changed)// tylko, gdy jakieś pole zmienione
                {
                    tgl = new TagLibConnector();
                    //
                    if (null != tgl)
                    {
                        //
                        tgl.tagTrack = dataSet1.DirTable1[k].tagTrack;
                        tgl.tagTitle = dataSet1.DirTable1[k].tagTitle;
                        tgl.tagArtist = dataSet1.DirTable1[k].tagArtist;
                        tgl.tagAlbum = dataSet1.DirTable1[k].tagAlbum;
                        tgl.tagYear = dataSet1.DirTable1[k].tagYear;
                        tgl.tagGenre = dataSet1.DirTable1[k].tagGenre;
                        //
                        if(tgl.WriteTags(nameOld))
                        //
                        //if(tgl.WriteTags(nameOld, dataSet1.DirTable1[k].tagTrack, dataSet1.DirTable1[k].tagTitle, dataSet1.DirTable1[k].tagArtist, dataSet1.DirTable1[k].tagAlbum, dataSet1.DirTable1[k].tagYear, dataSet1.DirTable1[k].tagGenre))
                        {
                            ;
                        }
                    }
                }
                //
                //
                if (dataSet1.DirTable1[k].FileName_Changed)
                {
                    try
                    {
                        //File.Move(nameOld, nameNew);
                        Utils.Rename(nameOld, nameNew);
                    }
                    catch (Exception e2)
                    {
                        MessageBox.Show(e2.Message, "Rename(" + nameOld + "," + "nameNew" + ")");
                    }
                }
                //
                dataSet1.DirTable1[k].Marker = false;
            }
            checkBox_UpdateTags.Checked = false;
            Cursor.Current = Cursors.Default;
            //
            if (Directory.Exists(StartDirectory))
            {
                WaitingTooLong wtl = new WaitingTooLong(5);
                //this.Enabled = false;
                loadDir();
                //this.Enabled = true;
                wtl.isTooLongBeep(this.Handle);
                afterLoad(false);
            }
            //
            //DoClean();
            //
            //
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        private string GetLegalTrackNumber(string s)
        {
            if (null == s) return s;
            if ("" == s) return s;
            s = s.Trim();
            if (s.Length < 2) return "0" + s;
            return s;
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        private void RenumberTracks()
        {
            Cursor.Current = Cursors.WaitCursor;
            int n = 1;
            for (int k = 0; k < dataSet1.DirTable1.Count; k++)
            {
                //if (Utils.isTrackNumberEmpty(dataSet1.DirTable1[k].tagTrack)) continue;
                //
                dataGridView1.Rows[k].Cells["tagTrackDataGridViewTextBoxColumn"].Value = Utils.Number2Track(n); n++;
                dataGridView1.Rows[k].Cells["tagTrackChangedDataGridViewCheckBoxColumn"].Value = true;
                dataGridView1.Rows[k].Cells["markerDataGridViewCheckBoxColumn"].Value = true;
            }
            checkBox_UpdateTags.Checked = false;
            Cursor.Current = Cursors.Default;
            //
            return;
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        private void MultiplyTrackNumber(int nOffset, string multiplier)
        {
            //
            int n = nOffset + int.Parse(multiplier);
            int iv;
            //
            //
            Cursor.Current = Cursors.WaitCursor;
            for (int k = 0; k < dataSet1.DirTable1.Count; k++)
            {
                if (Utils.isTrackNumberEmpty(dataSet1.DirTable1[k].FileTrack)) continue;
                if (!int.TryParse(dataSet1.DirTable1[k].FileTrack, out iv)) continue;
                //
                dataSet1.DirTable1[k].FileTrack = GetLegalTrackNumber(((n*100) + iv).ToString());
                dataSet1.DirTable1[k].FileName_Changed = true;
                dataSet1.DirTable1[k].Marker = true;
            }
            checkBox_UpdateTags.Checked = false;
            Cursor.Current = Cursors.Default;
            //
            return;
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        private int getMaxTrackNumber()
        {
            int n = 0;
            int iv;
            for (int k = 0; k < dataSet1.DirTable1.Count; k++)
            {
                if (Utils.isTrackNumberEmpty(dataSet1.DirTable1[k].tagTrack)) continue;
                if (!int.TryParse(dataSet1.DirTable1[k].tagTrack, out iv)) continue;
                //
                if (iv > n) n = iv;
            }

            return n;
        }

        //---------------------------------------------------------------------------------------------------------------------------------
        private void changeCase(int col, int rowMin, int rowMax, CaseUtils.CASE c)
        {
            for (int n = rowMin; n < rowMax; n++)
            {
                switch (dataSet1.DirTable1.Columns[dragCol].ColumnName)
                {
                    case "FileName":
                        dataGridView1.Rows[n].Cells["fileNameDataGridViewTextBoxColumn"].Value = CaseUtils.ChangeCase(c, dataGridView1.Rows[n].Cells["fileNameDataGridViewTextBoxColumn"].Value.ToString());
                        dataGridView1.Rows[n].Cells["FilenameChangedDataGridViewCheckBoxColumn"].Value = true;
                        dataGridView1.Rows[n].Cells["markerDataGridViewCheckBoxColumn"].Value = true;
                        break;
                    case "tagTitle":
                        dataGridView1.Rows[n].Cells["tagTitleDataGridViewTextBoxColumn"].Value = CaseUtils.ChangeCase(c, dataGridView1.Rows[n].Cells["tagTitleDataGridViewTextBoxColumn"].Value.ToString());
                        dataGridView1.Rows[n].Cells["tagTitleChangedDataGridViewCheckBoxColumn"].Value = true;
                        dataGridView1.Rows[n].Cells["markerDataGridViewCheckBoxColumn"].Value = true;
                        checkBox_UpdateTags.Checked = true;
                        break;
                    case "tagArtist":
                        dataGridView1.Rows[n].Cells["tagArtistDataGridViewTextBoxColumn"].Value = CaseUtils.ChangeCase(c, dataGridView1.Rows[n].Cells["tagArtistDataGridViewTextBoxColumn"].Value.ToString());
                        dataGridView1.Rows[n].Cells["tagArtistChangedDataGridViewCheckBoxColumn"].Value = true;
                        dataGridView1.Rows[n].Cells["markerDataGridViewCheckBoxColumn"].Value = true;
                        checkBox_UpdateTags.Checked = true;
                        break;
                    case "tagAlbum":
                        dataGridView1.Rows[n].Cells["tagAlbumDataGridViewTextBoxColumn"].Value = CaseUtils.ChangeCase(c, dataGridView1.Rows[n].Cells["tagAlbumDataGridViewTextBoxColumn"].Value.ToString());
                        dataGridView1.Rows[n].Cells["tagAlbumChangedDataGridViewCheckBoxColumn"].Value = true;
                        dataGridView1.Rows[n].Cells["markerDataGridViewCheckBoxColumn"].Value = true;
                        checkBox_UpdateTags.Checked = true;
                        break;
                }
            }//for
            //
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        private string verifyNumber(string s, int maxDigits)
        {
            if (null == s) s = "";
            s = s.Trim();
            int n;
            if (int.TryParse(s, out n))
            {
                if (s.Length > maxDigits) return s.Substring(s.Length-maxDigits, maxDigits);
                return s;
            }

            return "";
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        private void sanitizeDataRow(int k)
        {
            if(Utils.isEmpty(dataSet1.DirTable1[k].tagTrack))dataSet1.DirTable1[k].tagTrack="";
            if(Utils.isEmpty(dataSet1.DirTable1[k].tagTitle))dataSet1.DirTable1[k].tagTitle="";
            if(Utils.isEmpty(dataSet1.DirTable1[k].tagArtist))dataSet1.DirTable1[k].tagArtist="";
            if(Utils.isEmpty(dataSet1.DirTable1[k].tagAlbum))dataSet1.DirTable1[k].tagAlbum="";
            if(Utils.isEmpty(dataSet1.DirTable1[k].tagYear))dataSet1.DirTable1[k].tagYear="";
            if(Utils.isEmpty(dataSet1.DirTable1[k].tagGenre))dataSet1.DirTable1[k].tagGenre="";
        }
        //---------------------------------------------------------------------------------------------------------------------------------
        private enum ContextMenuKind { TextOperations, NextTrackNumber, TrackNumbersOperations};
        //---------------------------------------------------------------------------------------------------------------------------------
        private void selectContextMenuPart(ContextMenuKind cm)
        {
            switch (cm)
            {
                case ContextMenuKind.TextOperations:
                    sentenceCaseToolStripMenuItem.Visible = true;
                    lowercaseToolStripMenuItem.Visible = true;
                    uPPERCASEToolStripMenuItem.Visible = true;
                    capitalizeEachWordToolStripMenuItem.Visible = true;
                    tOGGLECASEToolStripMenuItem.Visible = true;
                    SwaplastFirstToolStripMenuItem.Visible = true;
                    //
                    nextNumberToolStripMenuItem.Visible = false;
                    //
                    clearAllNumbersToolStripMenuItem.Visible = false;
                    renumberToolStripMenuItem.Visible = false;
                    //
                    break;
                case ContextMenuKind.NextTrackNumber:
                    //
                    sentenceCaseToolStripMenuItem.Visible = false;
                    lowercaseToolStripMenuItem.Visible = false;
                    uPPERCASEToolStripMenuItem.Visible = false;
                    capitalizeEachWordToolStripMenuItem.Visible = false;
                    tOGGLECASEToolStripMenuItem.Visible = false;
                    SwaplastFirstToolStripMenuItem.Visible = false;
                    //
                    nextNumberToolStripMenuItem.Visible = true;
                    //
                    clearAllNumbersToolStripMenuItem.Visible = false;
                    renumberToolStripMenuItem.Visible = false;
                    //
                    break;
                case ContextMenuKind.TrackNumbersOperations:
                    //
                    sentenceCaseToolStripMenuItem.Visible = false;
                    lowercaseToolStripMenuItem.Visible = false;
                    uPPERCASEToolStripMenuItem.Visible = false;
                    capitalizeEachWordToolStripMenuItem.Visible = false;
                    tOGGLECASEToolStripMenuItem.Visible = false;
                    SwaplastFirstToolStripMenuItem.Visible = false;
                    //
                    nextNumberToolStripMenuItem.Visible = false;
                    //
                    clearAllNumbersToolStripMenuItem.Visible = true;
                    renumberToolStripMenuItem.Visible = true;
                    //
                    break;
            }
            //
        }
    }//class
}//namespace
